<?php 
/**
* Plugin Main Class
*/
class Flip_Book_VC
{
	
	function __construct()
	{
		add_action('vc_before_init', array($this, 'init_book'));
		add_action( 'plugins_loaded', array($this, 'init_book_textdomain' ) );
		add_action( 'init', array( $this, 'check_if_vc_is_install' ) );
	}

	function init_book_textdomain(){
		load_plugin_textdomain( 'flipbook', FALSE, basename( dirname( __FILE__ ) ) . '/languages/' );
	}	

	function init_book(){

		include 'flipbook.wrap.class.php';
		include 'flipbook.page.class.php';

	}

	function check_if_vc_is_install(){
        if ( ! defined( 'WPB_VC_VERSION' ) ) {
            // Display notice that Visual Compser is required
            add_action('admin_notices', array( $this, 'showVcVersionNotice' ));
            return;
        }			
	}

    function showVcVersionNotice() {
        echo '
        <div class="updated">
          <p><strong>3D Flip Book</strong> requires <strong><a href="http://codecanyon.net/item/visual-composer-page-builder-for-wordpress/242431?ref=WebCodingPlace" target="_blank">WPBakery Page Builder</a></strong> plugin to be installed and activated on your site.</p>
        </div>';
    }	
}
?>