<?php
if ( ! defined( 'ABSPATH' ) ) {
	die( '-1' );
}

class WPBakeryShortCode_flipbook_page extends WPBakeryShortCode {

	public $page_number = 0;
	public $content_arr = array();
	public $single_classes = array();

	protected function content( $attrs, $content = null ) {
		extract( shortcode_atts( array(
			'styles' 	=> '',
		), $attrs ) );
		$content = wpb_js_remove_wpautop( $content );
		$css_class = apply_filters( VC_SHORTCODE_CUSTOM_CSS_FILTER_TAG, vc_shortcode_custom_css_class( $styles, ' ' ), $this->settings['base'], $attrs );
		ob_start(); 
		global $wcp_flipbook_mode;
		?>

			<?php if ($wcp_flipbook_mode == 'single_pages') {
				$this->content_arr[] = $content;
				$this->single_classes[] = $css_class;
        		if ($this->page_number%2 != 0) {
        			echo '<div class="flipper-page" data-styles="'.htmlspecialchars(json_encode($this->single_classes)).'" data-imgurls="'.htmlspecialchars(json_encode($this->content_arr)).'"></div>';
        			$this->content_arr = array();
        			$this->single_classes = array();
        		}
        		$this->page_number++;
			} else { ?>
				<div class="flipper-page" data-styles="<?php echo esc_attr( $css_class ); ?>">
					<?php echo $content; ?>
				</div>
			<?php } ?>
		<?php return ob_get_clean();
	}
}

vc_map( array(
	'base' => 'flipbook_page',
	'name' => __( 'Book Page', 'flipbook' ),
	"as_child" => array('only' => 'wcp_flip_book'),
	"content_element" => true,
	'description' => 'Renders page for book',
	'icon' => plugins_url( 'images/book-page.png', dirname(__FILE__) ),
	'params' => array(
		array(
			'type' => 'textarea_html',
			'heading' => __( 'Contents', 'flipbook' ),
			'param_name' => 'content',
			'group' => 'Contents',
			'description' => __( 'Insert contents for this page', 'flipbook' ),
		),
		array(
			'type' => 'css_editor',
			'heading' => __( 'Styles', 'flipbook' ),
			'param_name' => 'styles',
			'group' => 'Page Settings',
			'description' => __( 'Styles and Settings for page', 'flipbook' ),
		),
	),
) );

