<?php
if ( ! defined( 'ABSPATH' ) ) {
	die( '-1' );
}

class WPBakeryShortCode_wcp_flip_book extends WPBakeryShortCodesContainer {

	protected function content( $attrs, $content = null ) {
		wp_enqueue_style( 'wcp-flipbook-styles', plugins_url( 'css/flipper.min.css' , dirname(__FILE__) ));
		wp_enqueue_script( 'wcp-flipbook-script', plugins_url( 'js/flipper.js' , dirname(__FILE__) ), array('jquery'));
		wp_enqueue_script( 'wcp-flipbook-trigger', plugins_url( 'js/script.js' , dirname(__FILE__) ), array('jquery'));
		wp_localize_script( 'wcp-flipbook-trigger', 'wcpbook', array('path' => plugins_url( 'images/' , dirname(__FILE__) ) ) );
		extract( shortcode_atts( array(
			'mode' 	=> 'dual_pages',
			'width' 	=> '700px',
			'height_desktop' 	=> '350x',
			'height_mobile' 	=> '200px',
			'mobile_size' 	=> '400px',
			'arrows' 	=> '',
			'tabs' 	=> '',
		), $attrs ) );
		$GLOBALS['wcp_flipbook_mode'] = $mode;
		$content = wpb_js_remove_wpautop( $content );
		ob_start(); ?>
		<style>
			.wcpflipbook {
				height: <?php echo $height_desktop; ?> !important;
			}
			.flipper-prev-page, .flipper-next-page {
				display: <?php echo ($arrows == 'true') ? 'block' : 'none' ; ?>
			}
			.flipper-pager-wrap {
				display: <?php echo ($tabs == 'true') ? 'block' : 'none' ; ?>
			}
			@media only screen and (max-width: <?php echo $mobile_size; ?>){
				.wcpflipbook {
					height: <?php echo $height_mobile; ?> !important;
				}
			}
		</style>
		<div class="bookwrap <?php echo $mode; ?>" style="width:100%;margin:0 auto;max-width:<?php echo $width; ?>;">
			<img class="book-loading" src="data:image/gif;base64,R0lGODlhAQABAIAAAAAAAP///yH5BAEAAAAALAAAAAABAAEAAAIBRAA7" alt="Loading" style="width:100%;height:1px;">
			<div class="wcpflipbook"
				data-mode="<?php echo $mode; ?>"
				data-width="<?php echo $width; ?>">
				<?php echo $content; ?>
			</div>
		</div>
		<?php return ob_get_clean();
	}
}

vc_map( array(
	'base' => 'wcp_flip_book',
	'name' => __( '3D Flip Book', 'flipbook' ),
	"as_parent" => array('only' => 'flipbook_page'),
	"content_element" => true,
	"js_view" => 'VcColumnView',
	'category' => 'Content',
	'description' => 'Displays Flip Book',
	'icon' => plugins_url( 'images/book-logo.png', dirname(__FILE__) ),
	'params' => array(
		array(
		    "type" => "dropdown",
		    "param_name" => "mode",
		    "heading" => __("Book Mode", "flipbook"),
		    "description" => __("Choose the particular mode of book", "flipbook"),
		    'value' => array(
		        __('Dual Pages', 'flipbook') => 'dual_pages',
		        __('Single Pages', 'flipbook') => 'single_pages',
		    ),
	    	'std' => 'dual_pages',
		),
		array(
			'type' => 'checkbox',
			'heading' => __( 'Arrows', 'flipbook' ),
			'param_name' => 'arrows',
			'description' => __( 'Check to display arrows with book', 'flipbook' ),
		),
		array(
			'type' => 'checkbox',
			'heading' => __( 'Tabs', 'flipbook' ),
			'param_name' => 'tabs',
			'description' => __( 'Check to display navigation tabs under book', 'flipbook' ),
		),
		array(
			'type' => 'textfield',
			'heading' => __( 'Width', 'flipbook' ),
			'param_name' => 'width',
			'description' => __( 'Provide width for book in pixels, eg 700', 'flipbook' ),
		),
		array(
			'type' => 'textfield',
			'heading' => __( 'Height for Desktop', 'flipbook' ),
			'param_name' => 'height_desktop',
			'description' => __( 'Provide height for desktop, eg 350px ', 'flipbook' ),
		),
		array(
			'type' => 'textfield',
			'heading' => __( 'Height for Mobile', 'flipbook' ),
			'param_name' => 'height_mobile',
			'description' => __( 'Provide height for mobile devices, eg 250px', 'flipbook' ),
		),
		array(
			'type' => 'textfield',
			'heading' => __( 'Mobile Screen Size', 'flipbook' ),
			'param_name' => 'mobile_size',
			'value' => '450px',
			'description' => __( 'Provide width from where mobile size starts', 'flipbook' ),
		),
	),
) );

